package com.nabisoft.tutorials.mavenstruts.ejb;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;

import com.nabisoft.tutorials.mavenstruts.entity.Message;
import java.util.List;

@Stateless
public class MessageServiceBean{
	
	@PersistenceContext
    private EntityManager em;
    
    
    
	public List<Message> findAllMessages() {
		TypedQuery<Message> query = em.createQuery("SELECT msg FROM Message msg", Message.class);
        return query.getResultList();
	}

	public Message find(Long id) {
        return em.find(Message.class, id);
    }
	
	public void save(Message msg) {
		em.persist(msg);		
	}
	
	public void remove(Long id) {
        Message message = find(id);
        if (message != null) {
            em.remove(message);
        }
    }
      
    public void remove(Message message) {
        if (message != null && message.getId()!=null && em.contains(message)) {
            em.remove(message);
        }
    }
	
}
